/*
 * FileHandlersFactory.java
 *
 * Created on 6  2002 ., 11:49
 */

package com.fn.spcave.compiler;


import java.util.HashMap;
import java.util.Map;
import java.lang.reflect.Constructor;


/**
 *
 * @author  asso
 */
public class FileHandlersFactory {
    
    private static Map handlers;
    private static Map classes;
    private static FileHandler copyHandler;
    
    static {
        handlers = new HashMap();
        classes = new HashMap();
        copyHandler = new CopyHandler();
        try {
         /*   addHandler("jpg", "com.fn.spcave.compiler.CopyHandler");
            addHandler("gif", "com.fn.spcave.compiler.CopyHandler");
            addHandler("jpeg", "com.fn.spcave.compiler.CopyHandler");
            addHandler("png", "com.fn.spcave.compiler.CopyHandler");
            addHandler("class", "com.fn.spcave.compiler.CopyHandler");
            addHandler("jar", "com.fn.spcave.compiler.CopyHandler");
            addHandler("rar", "com.fn.spcave.compiler.CopyHandler");
            addHandler("zip", "com.fn.spcave.compiler.CopyHandler");
            addHandler("properties", "com.fn.spcave.compiler.CopyHandler");
            addHandler("doc", "com.fn.spcave.compiler.CopyHandler");
            addHandler("ico", "com.fn.spcave.compiler.CopyHandler");
            addHandler("rtf", "com.fn.spcave.compiler.CopyHandler");
            addHandler("exe", "com.fn.spcave.compiler.CopyHandler");
            addHandler("cgi", "com.fn.spcave.compiler.CopyHandler");
            addHandler("pl", "com.fn.spcave.compiler.CopyHandler");
            addHandler("asp", "com.fn.spcave.compiler.CopyHandler");
            addHandler("php", "com.fn.spcave.compiler.CopyHandler");
            addHandler("xml", "com.fn.spcave.compiler.CopyHandler");
            addHandler("css", "com.fn.spcave.compiler.CopyHandler");
            addHandler("htm", "com.fn.spcave.compiler.CopyHandler");
            addHandler("html", "com.fn.spcave.compiler.CopyHandler");*/
            
            addHandler("scp", "com.fn.spcave.compiler.DummyHandler");
            addHandler("sch", "com.fn.spcave.compiler.DummyHandler");
            addHandler("scc", "com.fn.spcave.compiler.DummyHandler");
            
            addHandler("sct", "com.fn.spcave.compiler.TemplateHandler");
            addHandler("scs", "com.fn.spcave.compiler.ScriptHandler");
        } catch (Exception e) { }
    }

    public static void addHandler(String fileType, String className) throws ScException {
        String s = fileType.toLowerCase();
        FileHandler f = (FileHandler)classes.get(className);
        if (f == null) {
            try {
                Class cl = Class.forName(className);
                Constructor cn = cl.getConstructor(new Class[0]);
                f = (FileHandler)cn.newInstance(null);
                classes.put(className, f);
            } catch (Exception e) {
                throw new ScException("Error adding handler '" + fileType + ":" + className + "': "
                        + e.getMessage());
            }
        }
        handlers.put(fileType, f);
    }
    
    public static FileHandler getHandler(String fileExt) {
        FileHandler fh = (FileHandler)handlers.get(fileExt.toLowerCase());
        if (fh == null)
            return copyHandler;
        else
            return fh;
    }
    
}
