/*
 * FunctionsRegistry.java
 *
 * Created on 15  2002 ., 14:10
 */

package com.fn.spcave.compiler;


import java.lang.reflect.Constructor;
import java.util.HashMap;
import java.util.Map;


/**
 *
 * @author  asso
 */
public class FunctionsRegistry {
    
    private static Map handlers;
    private static Map classes;

    static {
        handlers = new HashMap();
        classes = new HashMap();
        try {
            addFunction("text", "com.fn.spcave.compiler.TextFunction");
            addFunction("get", "com.fn.spcave.compiler.GetFunction");
            addFunction("isSet", "com.fn.spcave.compiler.IssetFunction");
            addFunction("getPath", "com.fn.spcave.compiler.GetPathFunction");
            addFunction("eq", "com.fn.spcave.compiler.EqFunction");
            addFunction("seq", "com.fn.spcave.compiler.SEqFunction");
            addFunction("getDate", "com.fn.spcave.compiler.GetDateFunction");
            addFunction("not", "com.fn.spcave.compiler.NotFunction");
            addFunction("leq", "com.fn.spcave.compiler.LeqFunction");
            addFunction("geq", "com.fn.spcave.compiler.GeqFunction");
            addFunction("add", "com.fn.spcave.compiler.AddFunction");
            addFunction("sub", "com.fn.spcave.compiler.SubFunction");
            addFunction("cat", "com.fn.spcave.compiler.CatFunction");
        } catch (Exception e) { }
    }
    
    public static void addFunction(String function, String className) throws ScException {
        FunctionHandler f = (FunctionHandler)classes.get(className);
        if (f == null) {
            try {
                Class cl = Class.forName(className);
                Constructor cn = cl.getConstructor(new Class[0]);
                f = (FunctionHandler)cn.newInstance(null);
                classes.put(className, f);
            } catch (Exception e) {
                throw new ScException("Error adding function '" + function + ":" + className + "': "
                        + e.getMessage());
            }
        }
        handlers.put(function, f);
    }
    
    public static FunctionHandler getHandler(String function) {
        return (FunctionHandler)handlers.get(function);
    }    
    
}
