/*
 * KeywordInstruction.java
 *
 * Created on 16  2002 ., 11:33
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public abstract class KeywordInstruction extends Instruction {
    
    public static final int KEYWORD_CODE = 4;
    private List arguments;
    
    /** Creates a new instance of KeywordInstruction */
    public KeywordInstruction(Lexical lexical, String source, int line, 
            int position, List arguments) 
    {
        super(lexical, source, line, position, KEYWORD_CODE);
        this.arguments = arguments;
    }
    
    public List getArguments() {
        return arguments;
    }
    
    public abstract int processKeyword(Interpreter interp) throws ScException;
}
