/*
 * ScriptHandler.java
 *
 * Created on 22  2002 ., 14:10
 */

package com.fn.spcave.compiler;


import java.io.File;


/**
 *
 * @author  asso
 */
public class ScriptHandler implements FileHandler {
    
    /** Creates a new instance of ScriptHandler */
    public ScriptHandler() {
    }
    
    public void processFile(File file, File outputDir, String relativePath, String fileName, 
            Locale locale, String fileType, Compiler compiler) throws ScException 
    {
        try {
            if (! outputDir.exists())
                outputDir.mkdirs();
        } catch (Exception e) {
            throw new ScException("Error creating directory: " + e.getMessage());
        }
        
        processScript(file, compiler.getProject(), locale, relativePath, fileName, outputDir);
    }
    
    private void processScript(File file, Project project, Locale locale, 
            String relativePath, String fileName, File outputDir) throws ScException 
    {
        SourceReader sr = new ChainedSourceReader(file, locale);
        Lexical code = new Lexical(project, locale, file);
        code.analyse(sr);
        Interpreter intr = new Interpreter(project, file.getParentFile(), locale, 
                relativePath, fileName, outputDir);
        if (code.getSize() > 0)
            intr.processBlock(code, 0);
    }
}
