/*
 * SetKeyword.java
 *
 * Created on 19  2002 ., 12:17
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public class SetKeyword extends KeywordInstruction {
    
    /** Creates a new instance of SetKeyword */
    public SetKeyword(Lexical lexical, String source, int line, int position, 
            List arguments) throws ScException
    {
        super(lexical, source, line, position, arguments);
        if (arguments.size() != 2)
            throw new ScException(getErrorPos() + "set takes exacly one argument");
    }

    public int processKeyword(Interpreter interp) throws ScException {
        Expression name = (Expression)getArguments().get(0);
        Expression value = (Expression)getArguments().get(1);
        interp.setVariable(name.asString(interp), value.evaluate(interp));
        return getPosition() + 1;
    }
    
}
