/*
 * TemplateHandler.java
 *
 * Created on 6  2002 ., 12:53
 */

package com.fn.spcave.compiler;


import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;


/**
 *
 * @author  asso
 */
public class TemplateHandler implements FileHandler {
    
    /** Creates a new instance of TemplateHandler */
    public TemplateHandler() {
    }
    
    public void processFile(File file, File outputDir, String relativePath, String fileName, 
            Locale locale, String fileType, Compiler compiler) throws ScException 
    {
        String output = processTemplate(file, compiler.getProject(), locale, relativePath,
                fileName, outputDir);
        try {
            if (! outputDir.exists())
                outputDir.mkdirs();
            File outputFile = new File(outputDir, fileName + ".html");
            OutputStreamWriter out = new OutputStreamWriter(new FileOutputStream(outputFile), 
                    locale.getEncoding());
            out.write(output);
            out.close();
        } catch (Exception e) {
            throw new ScException("Error wriring file: " + e.getMessage());
        }
    }
    
    private String processTemplate(File file, Project project, Locale locale, 
            String relativePath, String fileName, File outputDir) throws ScException 
    {
        SourceReader sr = new ChainedSourceReader(file, locale);
        Lexical code = new Lexical(project, locale, file);
        code.analyse(sr);
        Interpreter intr = new Interpreter(project, file.getParentFile(), locale, 
                relativePath, fileName, outputDir);
        if (code.getSize() > 0)
            intr.processBlock(code, 0);
        return intr.getOutput();
    }
}
